// Program tworzy kolejnych potomkow (w liczbie podanej jako parametr 
// wejsciowy) i czeka na zakonczenie w kolejnosci od najmlodszego do 
// najstarszego tzn pierwszy zostanie zamkniety pstatni z powstalych 
// procesow
// (c) Kacper Kulczycki 2006
//************************************************************************** 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "err.h"
//***************************************************************************
int main(int argc, char *argv[])
{
  if (argc != 2) 
	{
	fatal("Brak zdefiniowanych parametrow dla %s", argv[0]);
	}
  pid_t pid;
  int indx;

  //  proces sie przedstawia: 
  printf("Jestem procesem o PID = %d\n", getpid());
  for(indx=0; indx<atoi(argv[1]);indx++) // tworzenie potomkow:
	{
	printf("fork'uje po raz %d.\n", indx+1);
	switch(pid=fork())
		{ 			
    		case -1:    
      			syserr("Cos nie tak w fork!!!\n"); // gdy blad
    		case 0: // gdy potomek
      			printf("Jestem potomkiem o PID = %d\n", getpid());
 			//sleep(8);
			break;
		default: // gdy proces jest procesem macierzystym
			printf("Jestem rodzicem o PID = %d\n", getpid());
      			printf("Wartosc PID mojego potomka = %d\n", pid);
			printf("czekam na proces o PID = %d\n", pid);
			//sleep(4);
			if (wait(0) == -1) 
       				{
					syserr("Cos nie tak w wait!!!\n");
				}
			//sleep(4);
			printf("proces o PID = %d zakonczyl sie\n", pid);
			exit(0);
		}
	}
  //sleep(5);
  //czekmy na zakonczenie potomkow
// for (indx=atoi(argv[1]); indx>0; indx--)
//	{
//		sleep(5);
	//	printf("Jestem procesem o PID = %d.\n",getpid());
	//printf("Teraz czekam na potomka o PID = %d.\n",pid);
//		if (wait(0) == -1)
//			{ 
//				syserr("Cos nie tak w wait!!!\n");
//			}
//	}
  exit(0);

}

